
###############################################################################
# Objective: linear
# Constraints: linear
###############################################################################
# A reference to your work
#
################################################################################


# number of x vars
param nx; # corresponds to K
#number of t
param nt;

# starting point (ampl needs also a starting point for t)
param xinit{1..nx};
param tinit{1..nt};


# x variables
var x {i in 1..nx} := xinit[i];
# t variable
var t {j in 1..nt} := tinit[j];


minimize fx:
    13*x[1]/144 + 1/8;

subject to tcons1:
           (t[1] + t[2]) - 2*(t[1]*t[2])^(1/3)
    - x[1]*((t[1])^(1/2) + (t[2])^(1/2) + (t[1]*t[2])^(1/2) - 3*(t[1]*t[2])^(1/3))
     <= 0;

    
subject to tbounds {i in 1..nt}:
    1e-6 <= t[i] <= 1;

subject to xbounds {i in 1..nx}:
    1 <= x[i] <= 4/3;


data;

param nx := 1; # corresponds to K
param nt := 2;

# Starting point
param xinit :=
    1 1.1;

param tinit :=
    1 0.1
    2 0.9;

# solve problem
# don't forget to write .col and .row files
option nsips_auxfiles rc;
option solver nsips;
option nsips_options 'method=disc_hett disc_h=0.001 disc_k=5';
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display x;
display fx;


