
###############################################################################
# Objective: linear
# Constraints: linear
###############################################################################
# A reference to your work
#
################################################################################


# number of x vars
param nx; # corresponds to K
#number of t
param nt;

# starting point (ampl needs also a starting point for t)
param xinit{1..nx};
param tinit{1..nt};


# x variables
var x {i in 1..nx} := xinit[i];
# t variable
var t {j in 1..nt} := tinit[j];


minimize fx:
    331*x[1]/648 - 311*x[2]/1296 + 37531*x[3]/810000 - 23/324;

subject to tcons1:
           (t[1] + t[2] + t[3] + t[4]) - 4*(t[1]*t[2]*t[3]*t[4])^(1/5)
    - x[1]*((t[1])^(1/2) + (t[2])^(1/2) + (t[3])^(1/2) + (t[4])^(1/2) + (t[1]*t[2])^(1/2) + (t[1]*t[3])^(1/2) + (t[1]*t[4])^(1/2) + (t[2]*t[3])^(1/2) + (t[2]*t[4])^(1/2) + (t[3]*t[4])^(1/2) - 10*(t[1]*t[2]*t[3]*t[4])^(1/5))
    + x[2]*((t[1]*t[2])^(1/3) + (t[1]*t[3])^(1/3) + (t[1]*t[4])^(1/3) + (t[2]*t[3])^(1/3) + (t[2]*t[4])^(1/3) + (t[3]*t[4])^(1/3) + (t[1]*t[2]*t[3])^(1/3) + (t[1]*t[2]*t[4])^(1/3) + (t[1]*t[3]*t[4])^(1/3) + (t[2]*t[3]*t[4])^(1/3) - 10*(t[1]*t[2]*t[3]*t[4])^(1/5))
    - x[3]*((t[1]*t[2]*t[3])^(1/4) + (t[1]*t[2]*t[4])^(1/4) + (t[1]*t[3]*t[4])^(1/4) + (t[2]*t[3]*t[4])^(1/4) + (t[1]*t[2]*t[3]*t[4])^(1/4) - 5*(t[1]*t[2]*t[3]*t[4])^(1/5))
     <= 0;

subject to xcons1:
    5 <= 10*x[1] - 10*x[2] + 5*x[3];
subject to xcons2:
         10*x[1] - 10*x[2] + 5*x[3] <= 6;
subject to xcons3:
    4 <= 10*x[1] - 10*x[2] + 4*x[3];
subject to xcons4:
    x[1] <= x[2];
subject to xcons5:
    x[2] <= x[3];
    
subject to tbounds {i in 1..nt}:
    1e-6 <= t[i] <= 1;

subject to xbounds {i in 1..nx}:
    1 <= x[i] <= 2;


data;

param nx := 3; # corresponds to K
param nt := 4;

# Starting point
param xinit :=
    1 1.1
    2 1.5
    3 2;

param tinit :=
    1 0.1
    2 0.2
    3 0.8
    4 0.9;

# solve problem
# don't forget to write .col and .row files
option nsips_auxfiles rc;
option solver nsips;
option nsips_options 'method=disc_hett disc_h=0.001 disc_k=5';
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display x;
display fx;


