###############################################################################
# Objective: linear
# Constraints: linear
###############################################################################
# A reference to your work
#
################################################################################


# number of x vars
param nx; # corresponds to K
#number of t
param nt;

# starting point (ampl needs also a starting point for t)
param xinit{1..nx};
param tinit{1..nt};


# x variables
var x {i in 1..nx} := xinit[i];
# t variable
var t {j in 1..nt} := tinit[j];


minimize fx:
    126730*x[1]/151263 - 317565*x[2]/537824 + 479072*x[3]/2100875 - 4856069*x[4]/130691232 - 6275/33614;

subject to tcons1:
           (t[1] + t[2] + t[3] + t[4] + t[5]) - 5*(t[1]*t[2]*t[3]*t[4]*t[5])^(1/6)
    - x[1]*((t[1])^(1/2) + (t[2])^(1/2) + (t[3])^(1/2) + (t[4])^(1/2) + (t[5])^(1/2) + (t[1]*t[2])^(1/2) + (t[1]*t[3])^(1/2) + (t[1]*t[4])^(1/2) + (t[1]*t[5])^(1/2) + (t[2]*t[3])^(1/2) + (t[2]*t[4])^(1/2) + (t[2]*t[5])^(1/2) + (t[3]*t[4])^(1/2) + (t[3]*t[5])^(1/2) + (t[4]*t[5])^(1/2) - 15*(t[1]*t[2]*t[3]*t[4]*t[5])^(1/6))
    + x[2]*((t[1]*t[2])^(1/3) + (t[1]*t[3])^(1/3) + (t[1]*t[4])^(1/3) + (t[1]*t[5])^(1/3) + (t[2]*t[3])^(1/3) + (t[2]*t[4])^(1/3) + (t[2]*t[5])^(1/3) + (t[3]*t[4])^(1/3) + (t[3]*t[5])^(1/3) + (t[4]*t[5])^(1/3) + (t[1]*t[2]*t[3])^(1/3) + (t[1]*t[2]*t[4])^(1/3) + (t[1]*t[2]*t[5])^(1/3) + (t[1]*t[3]*t[4])^(1/3) + (t[1]*t[3]*t[5])^(1/3) + (t[1]*t[4]*t[5])^(1/3) + (t[2]*t[3]*t[4])^(1/3) + (t[2]*t[3]*t[5])^(1/3) + (t[2]*t[4]*t[5])^(1/3) + (t[3]*t[4]*t[5])^(1/3) - 20*(t[1]*t[2]*t[3]*t[4]*t[5])^(1/6))
    - x[3]*((t[1]*t[2]*t[3])^(1/4) + (t[1]*t[2]*t[4])^(1/4) + (t[1]*t[2]*t[5])^(1/4) + (t[1]*t[3]*t[4])^(1/4) + (t[1]*t[3]*t[5])^(1/4) + (t[1]*t[4]*t[5])^(1/4) + (t[2]*t[3]*t[4])^(1/4) + (t[2]*t[3]*t[5])^(1/4) + (t[2]*t[4]*t[5])^(1/4) + (t[3]*t[4]*t[5])^(1/4) + (t[1]*t[2]*t[3]*t[4])^(1/4) + (t[1]*t[2]*t[3]*t[5])^(1/4) + (t[1]*t[2]*t[4]*t[5])^(1/4) + (t[1]*t[3]*t[4]*t[5])^(1/4) + (t[2]*t[3]*t[4]*t[5])^(1/4) - 15*(t[1]*t[2]*t[3]*t[4]*t[5])^(1/6))
    + x[4]*((t[1]*t[2]*t[3]*t[4])^(1/5) + (t[1]*t[2]*t[3]*t[5])^(1/5) + (t[1]*t[2]*t[4]*t[5])^(1/5) + (t[1]*t[3]*t[4]*t[5])^(1/5) + (t[2]*t[3]*t[4]*t[5])^(1/5) + (t[1]*t[2]*t[3]*t[4]*t[5])^(1/5) - 6*(t[1]*t[2]*t[3]*t[4]*t[5])^(1/6))
     <= 0;

subject to xcons1:
    -4 <= -15*x[1] + 20*x[2] - 15*x[3] + 6*x[4];
subject to xcons2:
          -15*x[1] + 20*x[2] - 15*x[3] + 6*x[4] <= -2;
subject to xcons3:
    -5 <= -15*x[1] + 20*x[2] - 15*x[3] + 5*x[4];
subject to xcons4:
    x[1] <= x[2];
subject to xcons5:
    x[2] <= x[3];
subject to xcons6:
    x[3] <= x[4];
    
subject to tbounds {i in 1..nt}:
    1e-6 <= t[i] <= 1;

subject to xbounds {i in 1..nx}:
    1 <= x[i] <= 2;


data;

param nx := 4; # corresponds to K
param nt := 5;

# Starting point
param xinit :=
    1 1.1
    2 1.5
    3 1.8
    4 2;

param tinit :=
    1 0.1
    2 0.2
    3 0.7
    4 0.8
    5 0.9;

# solve problem
# don't forget to write .col and .row files
option nsips_auxfiles rc;
option solver nsips;
option nsips_options 'method=disc_hett disc_h=0.1 disc_k=3';
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display x;
display fx;


