####################################################################
# Objective: Quadratic
# Constraints: Linear
#
# Sample problem in the user manual
#
# aivaz@dps.uminho.pt 27/12/99
####################################################################

var x {1..2};
# t var name must start with a t
var t;

#objective function
minimize fx: x[1]^2+x[2]^2;

# constraint depends on t, so name must star with a t
subject to tcons:
  x[1]*t+x[2]*t^2 <=  0;
# constraint does not depends on t, so name must not start with a t
subject to constraint:
  -10  <= x[1]+x[2] <=  10;

# bounds on t var
# ampl presolver will remove this constraint
subject to bounds:
  0 <= t <= 1;


###################
# End of Problem  #
###################

# don't forget to write .col and .row files
option nsips_auxfiles rc;
# this problem have no initial guess (starting point)
option reset_initial_guesses 1;
# change solver
option solver nsips;
# solve problem
solve;

##################
# Solution found #
##################
printf "Solution found\n";
display x;
display fx;
